//
//  CardSelectLayer.m
//  CowboyGame
//
//  Created by Michael on 28/01/2012.
//  Copyright 2012 __MyCompanyName__. All rights reserved.
//

#import "CardSelectLayer.h"


@interface CardSelectLayer()
-(void)displayCardMenu;
-(void)displayConfirm;

@end

@implementation CardSelectLayer

#pragma mark -
#pragma mark Functions Called
-(void)showMainMenu {
    CCLOG(@"Showing the Main Menu screen");
    [[GameManager sharedGameManager] runSceneWithID:kMainMenuScene];
}

-(void)showReadyUp {
    CCLOG(@"Showing the Ready Up Screen");
    [[GameManager sharedGameManager] runSceneWithID:kReadyUp];
}

-(void)doNothing {
    CCLOG(@"THIS DON'T DO STUFF");
}

-(void)cardSelected: (id)sender {
    cardNumberSelected++;
    if(cardNumberSelected >= 4){
        CCLOG(@"MAXIMUM NUMBER OF CARDS SELECTED");
        // return on screen variable?
        return;
    }else {
        //write to the plist the card ID
        CCMenuItem *itm = (CCMenuItem *) sender;
        
        int cardID = (int)itm.tag;
        
        NSError *error;
        NSArray *paths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES); //1
        NSString *documentsDirectory = [paths objectAtIndex:0]; //2
        NSString *path = [documentsDirectory stringByAppendingPathComponent:@"SelectedCards.plist"]; //3
        
        NSFileManager *fileManager = [NSFileManager defaultManager];
        
        if (![fileManager fileExistsAtPath: path]) //4
        {
            NSString *bundle = [[NSBundle mainBundle] pathForResource:@"SelectedCards" ofType:@"plist"]; //5
            
            [fileManager copyItemAtPath:bundle toPath: path error:&error]; //6
        }
    
        NSMutableDictionary *data = [[NSMutableDictionary alloc] initWithContentsOfFile: path];
        
        NSMutableString *cardNumber = [NSMutableString stringWithString:@"Card "];
        [cardNumber appendFormat:@"%d", cardNumberSelected];
        
        NSNumber *cardIdentifyer = [NSNumber numberWithInt:cardID];
        
        [data setObject:cardIdentifyer forKey:cardNumber];
        
        [data writeToFile: path atomically:YES];
        [data release];
        CCLOG(@"Card Selected%d", cardID);
        
    }
}

-(void)clearAndGoBack {
    // Clear out the plist
    NSError *error;
    NSArray *paths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES); //1
    NSString *documentsDirectory = [paths objectAtIndex:0]; //2
    NSString *path = [documentsDirectory stringByAppendingPathComponent:@"SelectedCards.plist"]; //3
    
    NSFileManager *fileManager = [NSFileManager defaultManager];
    
    if (![fileManager fileExistsAtPath: path]) //4
    {
        NSString *bundle = [[NSBundle mainBundle] pathForResource:@"SelectedCards" ofType:@"plist"]; //5
        
        [fileManager copyItemAtPath:bundle toPath: path error:&error]; //6
    }
    
    NSMutableDictionary *data = [[NSMutableDictionary alloc] initWithContentsOfFile: path];
    
    //Change card
    for (int i=0; i<4; i++) {
        [data setObject:[NSNumber numberWithInt:12] forKey:[NSNumber numberWithInt:i]];
    }
    
    [data writeToFile: path atomically:YES];
    [data release];
    numberOfCards = 0;
    cardNumberSelected = 0;
    
    CCLOG(@"Card Selection Cleared");
    
    // Go back to card select
    [self displayCardMenu];
}

#pragma mark -
#pragma mark Menus
-(void)displayCardMenu {
    CGSize screenSize = [CCDirector sharedDirector].winSize;
    if (confirmMenu != nil) {
        [confirmMenu removeFromParentAndCleanup:YES];
    }
    
    // Tier1
    CCMenuItem *bartender = [CCMenuItemImage itemFromNormalImage:@"1bartender.png" selectedImage:@"cardSelected.png" target:self selector:@selector(cardSelected:)];
    bartender.tag = 0;
    CCMenuItem *shopkeeper = [CCMenuItemImage itemFromNormalImage:@"1ShopKeeper.png" selectedImage:@"cardSelected.png" target:self selector:@selector(cardSelected:)];
    shopkeeper.tag = 1;
    CCMenuItem *cattleman = [CCMenuItemImage itemFromNormalImage:@"1Cowboy.png" selectedImage:@"cardSelected.png" target:self selector:@selector(cardSelected:)];
    cattleman.tag = 2;
    CCMenuItem *mayor = [CCMenuItemImage itemFromNormalImage:@"1Mayor.png" selectedImage:@"cardSelected.png" target:self selector:@selector(cardSelected:)];
    mayor.tag = 3;
    
    // Tier 2
    CCMenuItem *furTrapper = [CCMenuItemImage itemFromNormalImage:@"2FurTrapper.png" selectedImage:@"cardSelected.png" target:self selector:@selector(cardSelected:)];
    furTrapper.tag = 4;
    CCMenuItem *sheriff = [CCMenuItemImage itemFromNormalImage:@"2Sheriff.png" selectedImage:@"cardSelected.png" target:self selector:@selector(cardSelected:)];
    sheriff.tag = 5;
    CCMenuItem *pinkerton = [CCMenuItemImage itemFromNormalImage:@"2Pinkerton.png" selectedImage:@"cardSelected.png" target:self selector:@selector(cardSelected:)];
    pinkerton.tag = 6;
    CCMenuItem *armyOfficer = [CCMenuItemImage itemFromNormalImage:@"2ArmyOfficer.png" selectedImage:@"cardSelected.png" target:self selector:@selector(cardSelected:)];
    armyOfficer.tag = 7;
    
    // Tier 3
    CCMenuItem *manWithNoName = [CCMenuItemImage itemFromNormalImage:@"3TheManWithNoName.png" selectedImage:@"cardSelected.png" target:self selector:@selector(cardSelected:)];
    manWithNoName.tag = 8;
    CCMenuItem *jesseJames = [CCMenuItemImage itemFromNormalImage:@"3JesseJames.png" selectedImage:@"cardSelected.png" target:self selector:@selector(cardSelected:)];
    jesseJames.tag = 9;
    CCMenuItem *johnMarston = [CCMenuItemImage itemFromNormalImage:@"3JohnMartston.png" selectedImage:@"cardSelected.png" target:self selector:@selector(cardSelected:)];
    johnMarston.tag = 10;
    CCMenuItem *billyTheKid = [CCMenuItemImage itemFromNormalImage:@"3BillyTheKid.png" selectedImage:@"cardSelected.png" target:self selector:@selector(cardSelected:)];
    billyTheKid.tag = 11;
    
    
    // Bottom Control Menu
    CCMenuItem *play = [CCMenuItemFont itemFromString:@"Play" target:self selector:@selector(displayConfirm)];
    CCMenuItem *back = [CCMenuItemFont itemFromString:@"Back" target:self selector:@selector(showMainMenu)];
    [(CCMenuItemFont *)play setColor:ccBLACK];
    [(CCMenuItemFont *)back setColor:ccBLACK];
    
    cardSelectMenu1 = [CCMenu menuWithItems:bartender,shopkeeper,cattleman,mayor, nil];
    [cardSelectMenu1 alignItemsVerticallyWithPadding:screenSize.height *0.040f];
    [cardSelectMenu1 setPosition:ccp(90,190)];
    [self addChild:cardSelectMenu1 z:0 tag:kCardSelectTagValue];
    
    cardSelectMenu2 = [CCMenu menuWithItems:furTrapper,sheriff,pinkerton,armyOfficer, nil];
    [cardSelectMenu2 alignItemsVerticallyWithPadding:screenSize.height *0.040f];
    [cardSelectMenu2 setPosition:ccp(240,190)];
    [self addChild:cardSelectMenu2 z:0];
    
    cardSelectMenu3 = [CCMenu menuWithItems:manWithNoName,jesseJames,johnMarston,billyTheKid, nil];
    [cardSelectMenu3 alignItemsVerticallyWithPadding:screenSize.height *0.040f];
    [cardSelectMenu3 setPosition:ccp(390,190)];
    [self addChild:cardSelectMenu3 z:0];
    
    controlsMenu = [CCMenu menuWithItems:play,back, nil];
    [controlsMenu alignItemsHorizontallyWithPadding:20.0f];
    [controlsMenu setPosition:ccp(240,50)];
    [self addChild:controlsMenu z:1];
}

-(void)displayConfirm {
    CGSize screenSize = [CCDirector sharedDirector].winSize;
    if (cardSelectMenu1 != nil) {
        [cardSelectMenu1 removeFromParentAndCleanup:YES];
    }
    if (cardSelectMenu2 != nil) {
        [cardSelectMenu2 removeFromParentAndCleanup:YES];
    }
    if (cardSelectMenu3 != nil) {
        [cardSelectMenu3 removeFromParentAndCleanup:YES];
    }
    
    if (controlsMenu != nil) {
        [controlsMenu removeFromParentAndCleanup:YES];
    }
    
    // Setup Main Menu Items
    CCMenuItem *confirm = [CCMenuItemFont itemFromString:@"Confirm" target:self selector:@selector(showReadyUp)];
    [(CCMenuItemFont *)confirm setColor:ccBLACK];
    CCMenuItem *back = [CCMenuItemFont itemFromString:@"Re-Select" target:self selector:@selector(clearAndGoBack)];
    [(CCMenuItemFont *)back setColor:ccBLACK];
    
    confirmMenu = [CCMenu menuWithItems:confirm,back, nil];
    [confirmMenu alignItemsVerticallyWithPadding:screenSize.height *0.059f];
    [confirmMenu setPosition:ccp(240,160)];
    [self addChild:confirmMenu z:2 tag:kCardConfirmTagValue];
}

#pragma mark -
#pragma mark Init
-(id)init {
    self = [super init];
    if (self != nil) {
        //CGSize screenSize = [CCDirector sharedDirector].winSize;
        CCSprite *backgroundImage;
        backgroundImage = [CCSprite spriteWithFile:@"cardSelectBackground.png"];
        [backgroundImage setPosition: CGPointMake(240,160)];
        [self addChild:backgroundImage z:0 tag:0];
        [self displayCardMenu];
        cardNumberSelected = 0;
        numberOfCards = 0;
    
    }
    return self;
}


@end
