//
//  Constants.h
//  CowboyGame
//
//  Created by Michael on 07/02/2012.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#ifndef CowboyGame_Constants_h
#define CowboyGame_Constants_h

#define kMainMenuTagValue 10
#define kOptionsTagValue 20
#define kStatsTagValue 30
#define kCardSelectTagValue 40
#define kCardConfirmTagValue 50
#define kReadyUpTagValue 60
#define kReadiedUpTagValue 70
#define kResultsTagValue 80

typedef enum {
    kNoSceneUninitalized=0,
    kMainMenuScene=100,
    kOptions=200,
    kStats=300,
    kCardSelect=400,
    kReadyUp=500,
    kReadiedUp=600,
    kResults=700
}SceneTypes;

// Audio Items
#define AUDIO_MAX_WAITTIME 150

typedef enum {
    kAudioManagerUninitialized=0,
    kAudioManagerFailed=1,
    kAudioManagerInitializing=2,
    kAudioManagerInitialized=100,
    kAudioManagerLoading=200,
    kAudioManagerReady=300
    
} GameManagerSoundState;

// Audio Constants
#define SFX_NOTLOADED NO
#define SFX_LOADED YES

#define PLAYSOUNDEFFECT(...) \
[[GameManager sharedGameManager] playSoundEffect:@#__VA_ARGS__]

#define STOPSOUNDEFFECT(...) \
[[GameManager sharedGameManager] stopSoundEffect:__VA_ARGS__]

// Background Music
// Menu Scenes
#define BACKGROUND_TRACK_MAIN_MENU @"SoundLoop.mp3"

#define kFilteringFactor 0.1

#endif
