//
//  GameManager.h
//  CowboyGame
//
//  Created by Michael on 07/02/2012.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "Constants.h"
#import "SimpleAudioEngine.h"

@interface GameManager : NSObject {
    BOOL isMusicOn;
    SceneTypes currentScene;

    // Added for audio
    BOOL hasAudioBeenInitialized;
    GameManagerSoundState managerSoundState;
    SimpleAudioEngine *soundEngine;
    NSMutableDictionary *listOfSoundEffectFiles;
    NSMutableDictionary *soundEffectsState;
}
@property (readwrite) BOOL isMusicOn;

+(GameManager*)sharedGameManager;
-(void)runSceneWithID:(SceneTypes)sceneID;

@property (readwrite) GameManagerSoundState managerSoundState;

-(void)setupAudioEngine;
-(void)playBackgroundTrack:(NSString*)trackFileName;

@end
