//
//  Gameplay.m
//  CowboyGame
//
//  Created by Michael on 12/02/2012.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "Gameplay.h"
#import <Gamekit/Gamekit.h>


@implementation Gameplay

@synthesize serverPlayerAttack,serverPlayerDefence,serverPlayerFame,serverPlayerTotalValue;

@synthesize clientPlayerAttack,clientPlayerDefence,clientPlayerFame,clientPlayerTotalValue;

@synthesize endingType;

@synthesize gameSession;


- (id)init {
    CCLOG(@"Starting Gameplay");
    self = [super init];
    
    if (self) {
        peerPicker = [[GKPeerPickerController alloc] init];
        peerPicker.delegate = self;
        
        peerPicker.connectionTypesMask = GKPeerPickerConnectionTypeNearby;
        arrayPeers=[[NSMutableArray alloc] init];
        
        [self gameplayFunction];
    }

    return self;
}

- (void) gameplayFunction {
    // generate player values
    [self generateValues];
    
    // Connect
    CCLOG(@"Run connect to start peer picker");
    [peerPicker show];
    
    
    //calculate winner
    [self calculateWinner];
}


- (void) calculateWinner {
    serverPlayerTotalValue = (serverPlayerAttack - clientPlayerDefence + randomValue + (20 - serverPlayerFame));

    clientPlayerTotalValue = (clientPlayerAttack - serverPlayerDefence + randomValue + (20 - clientPlayerFame));


    if (serverPlayerTotalValue > clientPlayerTotalValue){
        endingType = 1;
        return;
    }
    if (serverPlayerTotalValue < clientPlayerTotalValue){
        endingType = 2;
        return;
    } else {
        endingType = 3;
        return;
    }
}


- (void) generateValues {
    
    // load IDs from selected Plist and into an array
    NSError *error;
    NSArray *paths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES); //1
    NSString *documentsDirectory = [paths objectAtIndex:0]; //2
    NSString *path = [documentsDirectory stringByAppendingPathComponent:@"SelectedCards.plist"]; //3
    
    NSFileManager *fileManager = [NSFileManager defaultManager];
    
    if (![fileManager fileExistsAtPath: path]) //4
    {
        NSString *bundle = [[NSBundle mainBundle] pathForResource:(@"SelectedCards") ofType:(@"plist")]; //5
        
        [fileManager copyItemAtPath:bundle toPath: path error:&error]; //6
    }
    
    NSMutableDictionary *savedStock = [[NSMutableDictionary alloc] initWithContentsOfFile: path];
    
    //load from savedStock
    int card1;
    int card2;
    int card3;
    
    card1 = [[savedStock objectForKey:@"1"] intValue];
    card2 = [[savedStock objectForKey:@"2"] intValue];
    card3 = [[savedStock objectForKey:@"3"] intValue];
    
    [savedStock release];
  
    // use loaded values to load card data
    NSString *path2 = [documentsDirectory stringByAppendingPathComponent:@"CardData.plist"];
    
    NSFileManager *fileManager2 = [NSFileManager defaultManager];
    
    if (![fileManager2 fileExistsAtPath: path2]) //4
    {
        NSString *bundle = [[NSBundle mainBundle] pathForResource:(@"SelectedCards") ofType:(@"plist")]; //5
        
        [fileManager2 copyItemAtPath:bundle toPath: path2 error:&error]; //6
    }
    
    NSMutableDictionary *savedStock2 = [[NSMutableDictionary alloc] initWithContentsOfFile: path2];
    
    NSArray *card1Data = [savedStock2 objectForKey:[NSNumber numberWithInt:card1]];
    NSArray *card2Data = [savedStock2 objectForKey:[NSNumber numberWithInt:card2]];
    NSArray *card3Data = [savedStock2 objectForKey:[NSNumber numberWithInt:card3]];
    
    int card1Attack = [[card1Data objectAtIndex:1] intValue];
    int card1Defence = [[card1Data objectAtIndex:2] intValue];
    int card1Fame = [[card1Data objectAtIndex:3] intValue];
    
    int card2Attack = [[card2Data objectAtIndex:1] intValue];
    int card2Defence = [[card2Data objectAtIndex:2] intValue];
    int card2Fame = [[card2Data objectAtIndex:3] intValue];
    
    int card3Attack = [[card3Data objectAtIndex:1] intValue];
    int card3Defence = [[card3Data objectAtIndex:2] intValue];
    int card3Fame = [[card3Data objectAtIndex:3] intValue];
    
    // from card data generate server attack, defence and remaining fame
    serverPlayerAttack = card1Attack + card2Attack + card3Attack;
    serverPlayerDefence = card1Defence + card2Defence +card3Defence;
    serverPlayerFame = card1Fame + card2Fame + card3Fame;
    
    // Generate Random value
    randomValue = ((rand() / RAND_MAX) * 20);
    
    // generate string to be sent via bluetooth
    NSMutableString* valuesString = [NSMutableString stringWithFormat:@"%d", serverPlayerAttack];
    [valuesString appendFormat:@":%d", serverPlayerDefence];
    [valuesString appendFormat:@":%d", serverPlayerFame];
    [valuesString appendFormat:@":%d", randomValue];
    
}

- (void) connectToPeers:(id) sender{
    [peerPicker show];
}

#pragma mark -
#pragma mark GKPeerPickerControllerDelegate

// This creates a unique Connection Type for this particular applictaion
- (GKSession *)peerPickerController:(GKPeerPickerController *)picker sessionForConnectionType:(GKPeerPickerConnectionType)type{
    // Create a session with a unique session ID - displayName:nil = Takes the iPhone Name
    GKSession* session = [[GKSession alloc] initWithSessionID:@"k0014561-CowboyGame" displayName:nil sessionMode:GKSessionModePeer];
    return [session autorelease];
}

// Tells us that the peer was connected
- (void)peerPickerController:(GKPeerPickerController *)picker didConnectPeer:(NSString *)peerID toSession:(GKSession *)session{
    
    // Get the session and assign it locally
    self.gameSession = session;
    session.delegate = self;
    
    //No need of teh picekr anymore
    picker.delegate = nil;
    [picker dismiss];
    [picker autorelease];
}

// Function to receive data when sent from peer
- (void)receiveData:(NSData *)data fromPeer:(NSString *)peer inSession: (GKSession *)session context:(void *)context
{
    //Convert received NSData to NSString to display
    CCLOG(@"Reccieved Data");
    
    NSString *clientData = [[NSString alloc] initWithData:data encoding:NSASCIIStringEncoding];
    NSArray *parsedClientData = [clientData componentsSeparatedByString:@":"];
    
    clientPlayerAttack = [[parsedClientData objectAtIndex:0] intValue];
    clientPlayerDefence = [[parsedClientData objectAtIndex:1] intValue];
    clientPlayerDefence = [[parsedClientData objectAtIndex:2] intValue];
    
    [clientData release];
}

- (void)session:(GKSession *)session peer:(NSString *)peerID didChangeState:(GKPeerConnectionState)state{
    
    if(state == GKPeerStateConnected){
        // Add the peer to the Array
        [arrayPeers addObject:peerID];
        
        NSString *str = [NSString stringWithFormat:@"Connected with %@",[session displayNameForPeer:peerID]];
        UIAlertView *alert = [[UIAlertView alloc] initWithTitle:@"Connected" message:str delegate:self cancelButtonTitle:@"OK" otherButtonTitles:nil];
        [alert show];
        [alert release];
        
        // Used to acknowledge that we will be sending data
        [session setDataReceiveHandler:self withContext:nil];
        
    }
    
}

@end