//
//  ReadyUpLayer.h
//  CowboyGame
//
//  Created by Michael on 03/02/2012.
//  Copyright 2012 __MyCompanyName__. All rights reserved.
//


#import <Foundation/Foundation.h>
#import "cocos2d.h"
#import "Constants.h"
#import "GameManager.h"
#import "SimpleAudioEngine.h"
#import <Gamekit/Gamekit.h>

@interface ReadyUpLayer : CCLayer <GKPeerPickerControllerDelegate, GKSessionDelegate> {
    CCMenu *readyUp;
    CCMenu *readiedUp;
    CCMenu *resultsMenu;
    
    int serverPlayerAttack;
    int serverPlayerDefence;
    int serverPlayerFame;
    int serverPlayerTotalValue;
    int serverPlayerRandomValue;
    
    int clientPlayerAttack;
    int clientPlayerDefence;
    int clientPlayerFame;
    int clientPlayerTotalValue;
    int clientPlayerRandomValue;
    
    int randomValue;
    
    int endingType;
    
    // Accelerometer
    UIAccelerometer *myAccelerometer;
    
    // Audio
    SimpleAudioEngine *soundEngine;
    
    // NETWORKING VARIABLES
	GKSession		*gameSession;
    // PeerPicker Object
    GKPeerPickerController *peerPicker;
    // Array of peers connected
    NSMutableArray *peerArray;
    
    // Sending Data
    NSMutableArray *sendingValues;
    
    
}

//Server player (own device) values
@property (nonatomic) int serverPlayerAttack;
@property (nonatomic) int serverPlayerDefence;
@property (nonatomic) int serverPlayerFame;
@property (nonatomic) int serverPlayerTotalValue;
@property (nonatomic) int serverPlayerRandomValue;

//Client player (other device) values
@property (nonatomic) int clientPlayerAttack;
@property (nonatomic) int clientPlayerDefence;
@property (nonatomic) int clientPlayerFame;
@property (nonatomic) int clientPlayerTotalValue;
@property (nonatomic) int clientPlayerRandomValue;


// NETWORKING VARIABLE ACCESSORS
@property(nonatomic, retain) GKSession   *gameSession;

//Calculates the winner of a comfrontation
- (void) startGameplay;

- (void) calculateWinner;

//Loads in the values from plist and other player
-(void) generateValues;

-(void)accelerometer:(UIAccelerometer *)accelerometer 
       didAccelerate:(UIAcceleration *)acceleration;

-(void)updateStats;

//Networking Code
- (void) connectToPeers:(id) sender;
- (void) sendPlayerData:(id)sender;

@end
